#include <stdio.h>
main(int ac,char **av)
{
  double x,y,xa,xd;
  char c1[14],c2[14];
  if(ac<5){ printf("\n\t **** adjust RA Dec using getcoord results ****\n\t");
         printf("\n\t Usage: adjust_radec displayRA displayDEC dRA dDEC\n");
         printf("\n\t Ex: adjust_radec 1:00 1:00 -20 30\n");
         printf("\n\t Notice: dRA,dDEC come from getcoord, in arcsec both\n\n");
         exit(0); }
  sscanf(av[3],"%lf",&x);
  sscanf(av[4],"%lf",&y);
  chs(av[1],&xa); xa-=x/54000.;
  chs(av[2],&xd); xd-=y/3600.;
  toms2(xa,c1,1);  toms2(xd,c2,0);
  printf("\n\t===> %s %s\n\n",c1,c2);
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
/*
 hour or degree to char_line
 if k=1 (hour case) in **:**:**.***
    k=0 (degree       -**:**:**.**
*/
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%4.1f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}
